class OddArray
  def initialize(arr)
    @arr = arr
  end

  def odd_each
    @arr.each do |number|
      yield number if number.odd?
    end
  end

  def odd_each_plus(num)
    return enum_for(:odd_each_plus, num) unless block_given?
    @arr.each do |number|
      yield(num + number) if number.odd?
    end
  end
end

array = OddArray.new([1, 4, 6, 5, 4, 8])
array.odd_each do |num|
  puts num
end

enum = array.enum_for(:odd_each)
pp enum.next
pp enum.next

array.odd_each_plus(10) do |num|
  puts num
end

enum_two = array.enum_for(:odd_each_plus, 15)
pp enum_two.next
pp enum_two.next

enum = array.enum_for(:odd_each)
enum.with_index do |number, order|
  puts "#{order}: #{number}"
end

data = array.enum_for(:odd_each).with_object([]) do |num, obj|
  obj << num
end
pp data

enum_more = array.odd_each_plus(6)
loop do
  puts enum_more.next
end

